/* bidirsortedset.c generated by valac 0.56.18, the Vala compiler
 * generated from bidirsortedset.vala, do not modify */

/* bidirsortedset.vala
 *
 * Copyright (C) 2012  Maciej Piechotka
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Maciej Piechotka <uzytkownik2@gmail.com>
 */

#include "gee.h"
#include <glib-object.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

static GType gee_bidir_sorted_set_get_type_once (void);

/**
 * Returns a {@link BidirIterator} that can be used for bi-directional
 * iteration over this sorted set.
 *
 * @return a {@link BidirIterator} over this sorted set
 */
GeeBidirIterator*
gee_bidir_sorted_set_bidir_iterator (GeeBidirSortedSet* self)
{
	GeeBidirSortedSetIface* _iface_;
#line 30 "bidirsortedset.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "bidirsortedset.vala"
	_iface_ = GEE_BIDIR_SORTED_SET_GET_INTERFACE (self);
#line 30 "bidirsortedset.vala"
	if (_iface_->bidir_iterator) {
#line 30 "bidirsortedset.vala"
		return _iface_->bidir_iterator (self);
#line 62 "bidirsortedset.c"
	}
#line 30 "bidirsortedset.vala"
	return NULL;
#line 66 "bidirsortedset.c"
}

/**
 * Returns an immutable empty sorted set.
 *
 * @return an immutable empty sorted set
 */
GeeBidirSortedSet*
gee_bidir_sorted_set_empty (GType g_type,
                            GBoxedCopyFunc g_dup_func,
                            GDestroyNotify g_destroy_func)
{
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	GeeBidirSortedSet* _tmp2_;
	GeeBidirSortedSet* _tmp3_;
	GeeBidirSortedSet* _tmp4_;
	GeeBidirSortedSet* result;
#line 43 "bidirsortedset.vala"
	_tmp0_ = gee_tree_set_new (g_type, (GBoxedCopyFunc) g_dup_func, (GDestroyNotify) g_destroy_func, NULL, NULL, NULL);
#line 43 "bidirsortedset.vala"
	_tmp1_ = _tmp0_;
#line 43 "bidirsortedset.vala"
	_tmp2_ = gee_abstract_bidir_sorted_set_get_read_only_view ((GeeAbstractBidirSortedSet*) _tmp1_);
#line 43 "bidirsortedset.vala"
	_tmp3_ = _tmp2_;
#line 43 "bidirsortedset.vala"
	_tmp4_ = _tmp3_;
#line 43 "bidirsortedset.vala"
	_g_object_unref0 (_tmp1_);
#line 43 "bidirsortedset.vala"
	result = _tmp4_;
#line 43 "bidirsortedset.vala"
	return result;
#line 101 "bidirsortedset.c"
}

GeeBidirSortedSet*
gee_bidir_sorted_set_get_read_only_view (GeeBidirSortedSet* self)
{
	GeeBidirSortedSetIface* _iface_;
#line 35 "bidirsortedset.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "bidirsortedset.vala"
	_iface_ = GEE_BIDIR_SORTED_SET_GET_INTERFACE (self);
#line 35 "bidirsortedset.vala"
	if (_iface_->get_read_only_view) {
#line 35 "bidirsortedset.vala"
		return _iface_->get_read_only_view (self);
#line 116 "bidirsortedset.c"
	}
#line 35 "bidirsortedset.vala"
	return NULL;
#line 120 "bidirsortedset.c"
}

static void
gee_bidir_sorted_set_default_init (GeeBidirSortedSetIface * iface,
                                   gpointer iface_data)
{
	/**
	 * The read-only view of this set.
	 */
#line 23 "bidirsortedset.vala"
	g_object_interface_install_property (iface, g_param_spec_object ("read-only-view", "read-only-view", "read-only-view", GEE_TYPE_BIDIR_SORTED_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 132 "bidirsortedset.c"
}

static GType
gee_bidir_sorted_set_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GeeBidirSortedSetIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gee_bidir_sorted_set_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType gee_bidir_sorted_set_type_id;
	gee_bidir_sorted_set_type_id = g_type_register_static (G_TYPE_INTERFACE, "GeeBidirSortedSet", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (gee_bidir_sorted_set_type_id, GEE_TYPE_SORTED_SET);
	return gee_bidir_sorted_set_type_id;
}

GType
gee_bidir_sorted_set_get_type (void)
{
	static volatile gsize gee_bidir_sorted_set_type_id__once = 0;
	if (g_once_init_enter (&gee_bidir_sorted_set_type_id__once)) {
		GType gee_bidir_sorted_set_type_id;
		gee_bidir_sorted_set_type_id = gee_bidir_sorted_set_get_type_once ();
		g_once_init_leave (&gee_bidir_sorted_set_type_id__once, gee_bidir_sorted_set_type_id);
	}
	return gee_bidir_sorted_set_type_id__once;
}

